using Learun.Application.TwoDevelopment.ZZDT_EC;
using Learun.Util;
using Learun.Util.Operat;
using System.Collections.Generic;
using System.Web.Mvc;

namespace Learun.Application.Web.Areas.ZZDT_EC.Controllers
{
    /// <summary>
    /// 版 本 PIT-ADMS V7.0.3 敏捷开发框架
    /// Copyright (c) 2013-2018 Hexagon PPM
    /// 创 建：超级管理员
    /// 日 期：2022-02-09 22:05
    /// 描 述：样板目录
    /// </summary>
    public class ec_template_catalogueController : MvcControllerBase
    {
        private ec_template_catalogueIBLL ec_template_catalogueIBLL = new ec_template_catalogueBLL();

        #region 视图功能

        /// <summary>
        /// 主页面
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        public ActionResult Index()
        {
            return View();
        }
        /// <summary>
        /// 表单页
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        public ActionResult Form()
        {
            return View();
        }
        #endregion

        #region 获取数据

        /// <summary>
        /// 获取列表数据
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetList(string queryJson)
        {
            var data = ec_template_catalogueIBLL.GetList(queryJson);
            return Success(data);
        }
        /// <summary>
        /// 获取列表分页数据
        /// <param name="pagination">分页参数</param>
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetPageList(string pagination, string queryJson)
        {
            Pagination paginationobj = pagination.ToObject<Pagination>();
            var data = ec_template_catalogueIBLL.GetList(queryJson, paginationobj);
            var jsonData = new
            {
                rows = data,
                total = paginationobj.total,
                page = paginationobj.page,
                records = paginationobj.records
            };
            return Success(jsonData);
        }
        /// <summary>
        /// 获取表单数据
        /// <param name="keyValue">主键</param>
        /// <summary>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetFormData(string keyValue, string ProjectId)
        {
            var data = ec_template_catalogueIBLL.GetEntity(keyValue, ProjectId);
            var jsonData = new
            {
                ec_template_catalogue = data
            };
            return Success(jsonData);
        }

        /// <summary>
        /// 获取样板目录树形数据
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        [AjaxOnly]
        public ActionResult GetTreeData(string ProjectId, string TemplateCatalogueID)
        {
            string queryJson = "{\"ProjectId\":\"" + ProjectId + "\",\"CurTemplateCatalogueID\":\"" + TemplateCatalogueID + "\"}";
            var list = ec_template_catalogueIBLL.GetList(queryJson);
            List<TreeModel> treeList = new List<TreeModel>();
            foreach (var item in list)
            {
                TreeModel node = new TreeModel();
                node.id = item.TemplateCatalogueID;
                node.text = item.TemplateCatalogueName;
                node.value = item.TemplateCatalogueID;
                node.showcheck = false;
                node.checkstate = 0;
                node.isexpand = false;
                node.parentId = item.UpTemplateCatalogueID;
                node.NodeExtData = item;
                treeList.Add(node);
            }
            return Success(treeList.ToTree());
        }
        #endregion

        #region 提交数据

        /// <summary>
        /// 删除实体数据
        /// <param name="keyValue">主键</param>
        /// <summary>
        /// <returns></returns>
        [HttpPost]
        [AjaxOnly]
        public ActionResult DeleteForm(string keyValue, string ProjectId)
        {
            ec_template_catalogueIBLL.DeleteEntity(keyValue, ProjectId);
            return Success("删除成功！", "样板文件目录", OperationType.Delete, null, null);
        }
        /// <summary>
        /// 保存实体数据（新增、修改）
        /// <param name="keyValue">主键</param>
        /// <summary>
        /// <returns></returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        [AjaxOnly]
        public ActionResult SaveForm(string keyValue, string strEntity, string ProjectId)
        {
            ec_template_catalogueEntity entity = strEntity.ToObject<ec_template_catalogueEntity>();
            ec_template_catalogueIBLL.SaveEntity(keyValue, entity, ProjectId);
            return Success("保存成功！", "样板文件目录", string.IsNullOrEmpty(keyValue) ? OperationType.Create : OperationType.Update, null, null);
        }
        #endregion

    }
}
